//Code cowritten by users Masky and Ivyyy for internal use in the 405th. Not intended to be used for commercial purposes.

#include <FastLED.h>
#include <Countimer.h>

#define NUM_LEDS 26     //LED setup
#define DATA_PIN 3
#define MAX_LIFE 3
CRGB leds[NUM_LEDS];
//uint8_t gHue = 0;
int tpin1 = 4;          //targets setup
int tpin2 = 5;
int tpin3 = 6;
int tpin4 = 7;
int tpin5 = 8;

int flashrt = 100;      //delay between target flashes
int state = 0;
int life = MAX_LIFE;           //value for life system
int timeLimit = 6;      //Actual times timeLimit * 5

Countimer timer;

void setup() {
  Serial.begin(9600);

  pinMode(tpin1, INPUT_PULLUP);
  pinMode(tpin2, INPUT_PULLUP);
  pinMode(tpin3, INPUT_PULLUP);
  pinMode(tpin4, INPUT_PULLUP);
  pinMode(tpin5, INPUT_PULLUP);


  FastLED.addLeds<NEOPIXEL, DATA_PIN>(leds, NUM_LEDS);
  FastLED.clear ();
  FastLED.show ();

  timer.setCounter(0, 0, timeLimit, timer.COUNT_DOWN, OnTimeout);

  changeColor(0, 2, CRGB::Green);
  changeColor(23, 25, CRGB::Green);
}

//state 0 Idle
//state 1 game
//state 2 training
//state 3 lost / return to idle
//state 4 super duper secret mode

void loop()
{
  timer.run();
  blue();

  if (state == 0) {
    if (digitalRead(tpin1) == LOW) {                                     //start game by pressing head
      changeColor  (19, 22, CRGB::Green);
      delay(2000);
      changeColor  (19, 22, CRGB::Black);
      changeColor  (3, 22, CRGB::White);
      delay(300);
      changeColor  (19, 22, CRGB::Black);
      state = 1;
      Serial.println(state);
      life = MAX_LIFE;
      timer.restart();
    }

    if ((digitalRead(tpin4) == LOW) && (digitalRead(tpin5) == LOW)) {
      state = 2;
    }

    if ((digitalRead(tpin2) == LOW) && (digitalRead(tpin3) == LOW)) {
      state = 4;
    }
  }

  if (state == 1) {                                                       // call game function
    game();
  }

  if (state == 2) {
    if ((digitalRead(tpin4) == LOW) && (digitalRead(tpin5) == LOW)) {
      state = 0;
      changeColor(0, 2, CRGB::Green);
      changeColor(23, 25, CRGB::Green);
    }
    else
      training();    
  }

  if (state == 3) {                                                       //when game ends, flash red, reset
    red();
    delay(800);
    state = 0;
  }

  if (state == 4) {                                                       //Rainbow
    // rainbow here
    changeColor  (19, 22, CRGB::Black);
    changeColor  (19, 22, CRGB::Purple);

    if ((digitalRead(tpin2) == LOW) && (digitalRead(tpin3) == LOW)) {
      state = 0;
    }
  }

}

void OnTimeout ()
{
  state = 3;
  Serial.println(state);
}

void blue()                                                                 //fills all targets blue
{
  changeColor  (3, 22, CRGB::Blue);
}

void red() {                                                                //fills all targets red
  changeColor  (3, 22, CRGB::Red);
}

void showLifeBar ()
{
  static int lastLife = 0;

  if (lastLife != life)
  {
    if (life < MAX_LIFE)
    {
      int lastLED = 25 - life;
      changeColor (23, lastLED, CRGB::Red);
    }

    changeColor(23 + (MAX_LIFE - life), 25, CRGB::Green);
    lastLife = life;

    Serial.println("ShowLifeBar");
  }
}

void training()
{
  changeColor (23, 25, CRGB::Yellow);
  changeColor (0, 2, CRGB::Yellow);

  if (digitalRead(tpin1) == LOW) {
    head();
  }
  if (digitalRead(tpin2) == LOW) {
    rarm();
  }
  if (digitalRead(tpin3) == LOW) {
    larm();
  }
  if (digitalRead(tpin4) == LOW) {
    lleg();
  }
  if (digitalRead(tpin5) == LOW) {
    rleg();
  }
}

void game() {
  changeColor(0, 2, CRGB::Green);

  //target switch signal read
  if (digitalRead(tpin1) == LOW) {
    head();
  }
  if (digitalRead(tpin2) == LOW) {
    rarm();
  }
  if (digitalRead(tpin3) == LOW) {
    larm();
  }
  if (digitalRead(tpin4) == LOW) {
    lleg();
  }
  if (digitalRead(tpin5) == LOW) {
    rleg();
  }

  showLifeBar();

  if (life <= 0)
  {
    changeColor (3, 22, CRGB::Green);
    timer.stop();
    state = 0;
    delay(800);
  }
}
void head() {                                                                //Aua Kopf
  flash(19);
  flash(19);
  flash(19);
  blue();

  --life;
}
void rarm()
{
  flash(15);
  flash(15);
  flash(15);
  blue();

  --life;
}

void larm()
{
  flash(11);
  flash(11);
  flash(11);
  blue();

  --life;
}
void lleg()
{
  flash(7);
  flash(7);
  flash(7);
  blue();

  --life;
}

void rleg()
{
  flash(3);
  flash(3);
  flash(3);
  blue();

  --life;
}

void flash (const int first)                                            //flash leds 3 times
{
  changeColor  (first, first + 3, CRGB::Red);
  delay (flashrt);

  changeColor  (first, first + 3, CRGB::Black);

  delay (flashrt);
}

void changeColor (const int first, const int last, const CRGB& color)  //function to change multiple led colors at once
{
  for (int i = first; i <= last; ++i)
    leds[i] = color;

  FastLED.show ();
}
